#!/bin/sh
#
# adoom
#
# Start $CLIENT_COUNT fdoom clients, and 1 adoom server
# 

FDOOM=${FDOOM:-../fdoom/fdoom}
ADOOM=${ADOOM:-./adoom}

CLIENT_COUNT=${CLIENT_COUNT:-4}
SERVER_COUNT=${SERVER_COUNT:-1}
TIMEOUT=${TIMEOUT:-20}
MILLISPERTIC=`expr 1000 / 35`
CLIENT_BASEPORT=${CLIENT_BASEPORT:-27000}
SERVER_BASEPORT=${CLIENT_BASEPORT:-28000}

# For more clients, use smaller XTERMs
if test $CLIENT_COUNT -gt 7; then
    XTERM="xterm -fn 5x7 -geometry 80x20"
elif test $CLIENT_COUNT -gt 4; then
    XTERM="xterm -fn 6x9 -geometry 80x30"
else
    XTERM="xterm -geometry 80x40 "
fi

HOST_IP=127.0.0.1
GDB=

PASSTHROUGHARGS=
for arg in "$@"; do 
    case "$arg" in
	-g)
	    GDB=/home/tullmann/bin/igdb
	    ;;
	-g2)
	    GDB=/home/aclement/janos/src/moab/envs/adoom/igdb
	    ;;
	-go)
	    GDB="/home/tullmann/bin/igdb -oskit"
	    ;;
	-p) 
	    FDOOM=`echo ${FDOOM} | sed -e 's/fdoom$/fdoom_p/'`
	    ADOOM=`echo ${ADOOM} | sed -e 's/adoom$/adoom_p/'`
	    ;;
	*)
	    PASSTHROUGHARGS="$PASSTHROUGHARGS $arg"
	    ;;
    esac
done

# Build list of N clients
i=0
clients=""
while test $i -lt $CLIENT_COUNT; do
    port=`expr ${CLIENT_BASEPORT} + $i`
    clients="$clients ${HOST_IP}:$port"
    i=`expr $i + 1`
done

serveraddr="${HOST_IP}:`expr ${SERVER_BASEPORT} + $i`"

# Fork off N ${FDOOM}s
pids=
for curr in $clients; do
    # Strip out current entry
    others=`echo $clients | sed -e "s/$curr//"`
    $XTERM -title "fdoom: $curr" -e $GDB $FDOOM \
	-myaddr $curr \
	-millispertic $MILLISPERTIC \
	-timeout $TIMEOUT \
	-adoomserver $serveraddr \
	$PASSTHROUGHARGS \
	$others &
    pids="$pids $!"
done

# Fork off 1 ${ADOOM}
adoompeers=""
#$XTERM -title "adoom: $serveraddr" -e 
$GDB $ADOOM \
	-myaddr $serveraddr \
	-timeout `expr $TIMEOUT + 10` \
	$PASSTHROUGHARGS \
	$adoompeers -- $clients # &

wait

#eof



