/*
 * stats.h
 *
 * Copyright (c) 2001 The University of Utah and the Flux Group.
 *
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

#ifndef STATS_HEADER
#define STATS_HEADER

#include "types.h"

typedef struct Stats 
{
	Uint32 clientPacketRecvCount;
	Uint32 clientPacketSentCount;
	Uint32 peerPacketRecvCount;
	Uint32 peerPacketSentCount;
	Uint32 connectPacketFromActive;
	Uint32 outOfOrderClientPacket;
	Uint32 peerLockAcquire;
	Uint32 peerLockRelease;
	Uint32 clientLockAcquire;
	Uint32 clientLockRelease;
	Uint32 blockOnPoolMutex;
	Uint32 poolWaitOnPbuf;
	Uint32 poolLockAcquire;
	Uint32 poolLockRelease;
} AdoomStats;

extern AdoomStats adoomStats;

#define STAT_INC(FIELD)        ((adoomStats.FIELD)++)
#define STAT_INCBY(FIELD, BY)  ((adoomStats.FIELD)+=(BY))
#define STAT_SET(FIELD, VAL)   ((adoomStats.FIELD)=VAL)
#define STAT_DEC(FIELD)        ((adoomStats.FIELD)--)

void statsInit(void);
void registerStatsTrigger(void);
void shutdownStats(void);
void printFinalStats(void);

#endif /* STATS_HEADeR */
