/*
 * Copyright (c) 2000, 2001, 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

#define NODEOS_SPEC_COMPAT

#include <nodeos/an_cred.h>
#include <nodeos/an_domain.h>
#include <nodeos/an_thread.h>

/*
 * Check to ensure all API calls exist.
 * This is intended to just be compiled/linked.
 * Running it may cause severe crashitude.
 */
an_Credentials *cred1;
an_Domain *domain1, *domain2;
an_ThreadPoolSpec *tspec;
an_MemSpec *mspec;
an_DomainInitFunc domaininit;
an_DomainTermFunc domainterm;
an_DomainStats fstats;
void *mem, *farg;

an_Thread *thread1;
void *targ;
static void tfunc(void *arg);

int
main(int argc, char **argv)
{
	an_Error err;

	/* Domain section */
	domain1 = an_domainCreate(mem, cred1, tspec, mspec,
				  domaininit, farg, domainterm);
	domain2 = an_domainId();
	err = an_domainStartThread(domain1, tfunc, targ, &thread1);
	err = an_domainStats(domain1, &fstats);
	err = an_domainDestroy(domain1);

	/* Thread section */
	return 0;
}

static void tfunc(void *arg)
{
}

