#
# Copyright (c) 1999, 2000 University of Utah and the Flux Group.
# All rights reserved.
# This file is part of Janos.
# 
# Janos is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License, version 2, as
# published by the Free Software Foundation.
# 
# Janos is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details, in the file
# COPYING.  If that file is not present, write to the Free
# Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
# 02111-1307, USA
# 
# The University of Utah and the Flux Group requests users to
# return to flux-dist@cs.utah.edu any improvements that they make.
#

### included by envs.mk and fdoom/fdoom.mk

### Setup the architecture-specific variables

include $(NODEOS_SRCDIR)/arch.mk

### Define some global settings for all EEs

CPPFLAGS = $(OPT_CFLAGS) $(ARCH_CFLAGS) -I$(NODEOS_OBJDIR) -I$(NODEOS_SRCDIR)

#CFLAGS_WARNINGS=-W -Wcast-align -Wwrite-strings -Wstrict-prototypes -Wmissing-prototypes -Wnested-externs -Winline
CFLAGS_WARNINGS = -Wwrite-strings -Wstrict-prototypes -Winline

ifneq ($(HOST_OS),solaris)	# these are too annoying on solaris
CFLAGS_WARNINGS += -Wcast-align -Wshadow
endif

CFLAGS += 	-Wall $(CPPFLAGS) $(CFLAGS_WARNINGS)

ifeq ($(HOST_OS),oskit)
LD_PFLAGS:=-pg -realtime
else
LD_PFLAGS:=-pg
endif

NODEOS_MAINOBJDIR := $(NODEOS_OBJDIR)/src
NODEOS_LIBDIR := $(NODEOS_OBJDIR)/lib
ifneq (,$(findstring CHAN_CLICK,$(CHANNELS)))
NODEOS_LIBS := 		-u main -L$(NODEOS_LIBDIR) -lmoabutil \
			-u ani_clickchan_instantiate \
			-L$(CLICK_INSTDIR)/lib -lclick \
			-L$(NODEOS_MAINOBJDIR) -lnodeos 
NODEOS_PLIBS := 	-u main $(LD_PFLAGS) -L$(NODEOS_LIBDIR) -lmoabutil_p \
			-L$(NODEOS_MAINOBJDIR) -lnodeos_p \
			-L$(CLICK_INSTDIR)/lib -lclick_p
else
NODEOS_LIBS := 		-u main -L$(NODEOS_LIBDIR) -lmoabutil \
			-L$(NODEOS_MAINOBJDIR) -lnodeos
NODEOS_PLIBS := 	-u main $(LD_PFLAGS) -L$(NODEOS_LIBDIR) -lmoabutil_p \
			-L$(NODEOS_MAINOBJDIR) -lnodeos_p
endif
NODEOS_LIB_DEPS := 	$(NODEOS_MAINOBJDIR)/libnodeos.a \
			$(NODEOS_LIBDIR)/libmoabutil.a
NODEOS_PLIB_DEPS := 	$(NODEOS_MAINOBJDIR)/libnodeos_p.a \
			$(NODEOS_LIBDIR)/libmoabutil_p.a


