/*
 * Copyright (c) 1999, 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

#define MAXPKTDATA	10

/*
 * *******************************************************************
 * NOTE: If any of the items in this file change, especially the
 * format of the control packet, please update the Java equivalent, or
 * ask Pat/Tim to update it.
 * *******************************************************************
 */

/*
 * A simple definition for a UDP packet that tells the demo what to do.
 */
typedef struct {
	int		opcode;
	int		subopcode;
	unsigned int	data[MAXPKTDATA];
} ctrl_packet_t;


#define CTRLPKTOP_FOO	 1
#define CTRLPKTOP_NETHOG 2
# define NETHOGCTRL_ON		1
# define NETHOGCTRL_OFF		2
# define NETHOGCTRL_BANDW	3 /* data[0] is new bandw in ??? */
#define CTRLPKTOP_CPUHOG 3
# define CPUHOGCTRL_ON		1
# define CPUHOGCTRL_OFF		2
# define CPUHOGCTRL_RATE	3
#define CTRLPKTOP_MEMHOG 4	/* mem hog is in java-demo only */
# define MEMHOGCTRL_ON		1
# define MEMHOGCTRL_OFF		2
#define CTRLPKTOP_PQ	 5
# define PQCTRL_ON		1
# define PQCTRL_OFF		2
#define CTRLPKTOP_CPUSCHED 6
# define CPUSCHEDCTRL_ON	1
# define CPUSCHEDCTRL_OFF	2
#define CTRLPKTOP_MEMLIMIT 7
# define MEMLIMITCTRL_ON	1
# define MEMLIMITCTRL_OFF	2
#define CTRLPKTOP_STATS	 8
# define STATSCTRL_TOTAL	1
# define STATSCTRL_DELTA	2
#define CTRLPKTOP_VERBOSE 9
# define VERBOSECTRL_ON		1
# define VERBOSECTRL_OFF	2
#define CTRLPKTOP_EXIT	 10

/*
 * For the control program.
 */
#define DEMOCTRL_FOO	"foo"
#define DEMOCTRL_NETHOG	"nethog"
#define DEMOCTRL_CPUHOG	"cpuhog"
#define DEMOCTRL_MEMHOG	"memhog"
#define DEMOCTRL_PQ	"pq"
#define DEMOCTRL_CPUSCHED "cpusched"
#define DEMOCTRL_MEMLIMIT "memlimit"
#define DEMOCTRL_STATS	"stats"
#define DEMOCTRL_VERBOSE "verbose"
#define DEMOCTRL_EXIT	"exit"
