#
# Copyright (c) 1999, 2000, 2001, 2002 University of Utah and the Flux Group.
# All rights reserved.
# This file is part of Janos.
# 
# Janos is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License, version 2, as
# published by the Free Software Foundation.
# 
# Janos is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details, in the file
# COPYING.  If that file is not present, write to the Free
# Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
# 02111-1307, USA
# 
# The University of Utah and the Flux Group requests users to
# return to flux-dist@cs.utah.edu any improvements that they make.
#

# The basics
EES = 	null domaintest chantest eventtest socktest getinfo threadtest rootdomain fs
EES += 	debugtest
# scheduling
EES += packsched cputest
ifneq ($(HOST_OS),solaris)
# require raw ethernet access
EES +=	pingreply forward packetdump ipforward
endif
ifneq ($(HOST_OS),oskit)
EES +=	anepdump
endif
ifneq (,$(findstring CHAN_CLICK,$(CHANNELS)))
#EES += udptest cutpingreply
EES += clickping clickmazunat chanlibudp chanlibudparp \
        chanlibudp2chans
endif
# oskit only
# XXX requires tweaking oskit/pq or it won't even compile
#ifeq ($(HOST_OS),oskit)
#EES += demo
#endif

SUBDIRS= libadoom fdoom adoom

CHECKABLE_EES = null rootflow threadtest eventtest socktest getinfo
ifeq ($(NODEOS_API),descrip)
EES += objtest
CHECKABLE_EES += objtest
endif

EES_P =	$(addsuffix _p, $(EES))

# mkmbimage additional command line arguments
#demo_MBFILES = "$(NODEOS_SRCDIR)/envs/mike-demo.config:demo.config"

#socktest_MBCLINE = "-moabdebug SOCKFD"
#EES = socktest.ofw
#SUBDIRS=

ifeq ($(ENABLE_PROFILING),yes)
all: $(EES) all_p
else
all: all.SUBDIRS $(EES)
endif

all_p: all_p.SUBDIRS $(EES_P)

### Define the EEs

include $(SRCDIR)/define_vars.mk

EE=null
EESRCS=null.c
include $(SRCDIR)/define_env.mk

EE=domaintest
EESRCS=domaintest.c
include $(SRCDIR)/define_env.mk

EE=chantest
EESRCS=chantest.c
include $(SRCDIR)/define_env.mk

EE=pingreply
EESRCS=pingreply.c
include $(SRCDIR)/define_env.mk

EE=packetdump
EESRCS=packetdump.c
include $(SRCDIR)/define_env.mk

EE=socktest
EESRCS=socktest.c
MBCLINE = $(socktest_MBCLINE)
include $(SRCDIR)/define_env.mk

EE=forward
EESRCS=forward.c
include $(SRCDIR)/define_env.mk

EE=ipforward
EESRCS=ipforward.c
include $(SRCDIR)/define_env.mk

EE=threadtest
EESRCS=threadtest.c
include $(SRCDIR)/define_env.mk

EE=eventtest
EESRCS=eventtest.c
include $(SRCDIR)/define_env.mk

EE=rootdomain
EESRCS=rootdomain.c
include $(SRCDIR)/define_env.mk

EE=cputest
EESRCS=cputest.c
include $(SRCDIR)/define_env.mk

EE=getinfo
EESRCS=getinfo.c
include $(SRCDIR)/define_env.mk

# cutpingreply broke with the new click lib
#EE=cutpingreply
#EESRCS=cutpingreply.c
#include $(SRCDIR)/define_env.mk

EE=clickping
EESRCS=clickping.c
include $(SRCDIR)/define_env.mk

EE=clickmazunat
EESRCS=clickmazunat.c
include $(SRCDIR)/define_env.mk

EE=chanlibudp
EESRCS=chanlibudp.c
include $(SRCDIR)/define_env.mk

EE=chanlibudparp
EESRCS=chanlibudparp.c
include $(SRCDIR)/define_env.mk

EE=chanlibudp2chans
EESRCS=chanlibudp2chans.c
include $(SRCDIR)/define_env.mk

#udptest broke with the new click lib
#EE=udptest
#EESRCS=udptest.c
#include $(SRCDIR)/define_env.mk

EE=packsched
EESRCS=packsched.c
include $(SRCDIR)/define_env.mk

EE=anepdump
EESRCS=anepdump.c
include $(SRCDIR)/define_env.mk

EE=demo
EESRCS=demo.c
MBFILES = $(demo_MBFILES)
include $(SRCDIR)/define_env.mk

EE=debugtest
EESRCS=debugtest.c
include $(SRCDIR)/define_env.mk

EE=fs
EESRCS=fs.c
include $(SRCDIR)/define_env.mk

EE=apicalls
EESRCS=apicalls.c
include $(SRCDIR)/define_env.mk

EE=objtest
EESRCS=objtest.c
include $(SRCDIR)/define_env.mk

%.MAKE:
	$(SILENT_MAKE_INFORM) "[$(basename $(notdir $@)) in envs/$(dir $@)]"
	@$(MAKE) -C $(dir $@) $(basename $(notdir $@))

%.SUBDIRS: $(addsuffix /%.MAKE,$(SUBDIRS)) ;

clean: clean.SUBDIRS
	$(SILENT_MAKE_INFORM) "Cleaning out *.o *.po *.d and the EEs."
	rm -f core *.d *.core *.o *.po $(EES) $(EES_P) \
	      cutpingreply *.mb *.ofw

depend:
	@echo "WARNING: depend target is deprecated."

distclean: clean distclean.SUBDIRS
	$(SILENT_MAKE_INFORM) "Scrubbing EE directory."
	rm -f GNUmakefile

install install_p: all
	@echo "The example EEs do not get installed."

ifeq ($(HOST_OS),oskit)
check:
	@echo "Cannot check EEs for an OSKit build.  (Must be able to run on build host.)"

else

check: check.SUBDIRS
	@for test in $(filter $(CHECKABLE_EES), $(EES)); do \
		echo " "; \
		echo "---- Running test $$test"; \
		./$$test || echo "FAIL: $$test (exited with code $$?)"; \
		echo " "; \
	done \

endif

.PHONY: all all_p
.PHONY: clean distclean
.PHONY: install install_p
.PHONY: check
