#!/bin/sh
#
# fdoom-net
#
# Start $PEER_COUNT fdoom clients that all shout at each other 
# for $TIMEOUT seconds
# 

if test -z "$FDOOM"; then
    FDOOM=./fdoom
fi

if test -z "$PEER_COUNT"; then
    #PEER_COUNT=10
    PEER_COUNT=4
fi

if test -z "$TIMEOUT"; then
    TIMEOUT=200
fi

# For more servers, use smaller XTERMs
if test $PEER_COUNT -gt 7; then
    XTERM="xterm -fn 5x7 -geometry 80x20"
elif test $PEER_COUNT -gt 4; then
    XTERM="xterm -fn 6x9 -geometry 80x30"
else
    XTERM="xterm -geometry 80x40 "
fi

TICKRATE=`expr 1000 / 35` # millis per tick
HOST_IP=127.0.0.1
GDB=

PASSTHROUGHARGS=
for arg in "$@"; do 
    case "$arg" in
	-g)
	    GDB=/home/tullmann/bin/igdb -d ../libadoom
	    ;;
	-g2)
	    GDB=/home/aclement/janos/src/moab/envs/fdoom/igdb -d ../libadoom
	    ;;
	-go)
	    GDB="/home/tullmann/bin/igdb -oskit"
	    ;;
	-p) 
	    FDOOM=`echo ${FDOOM} | sed -e 's/fdoom$/fdoom_p/'`
	    ;;
	*)
	    PASSTHROUGHARGS="$PASSTHROUGHARGS $arg"
	    ;;
    esac
done

# Build list of N peers
i=0
peers=""
while test $i -lt $PEER_COUNT; do
    port=`expr 23000 + $i`
    peers="$peers ${HOST_IP}:$port"
    i=`expr $i + 1`
done

# Fork off N ${FDOOM}s
pids=
for curr in $peers; do
    # Strip out current entry
    others=`echo $peers | sed -e "s/$curr//"`
    $XTERM -title "fdoom: $curr" -e bash -c "$GDB $FDOOM \
	-myaddr $curr \
	-millispertic $TICKRATE \
	-timeout $TIMEOUT \
	$PASSTHROUGHARGS \
	$others > log.$curr 2>&1" &
    pids="$pids $!"
done

#trap "echo; echo 'Abort.  Cleaning up...'; kill -9 ${pids}; exit 1" 1 2 3 13 15

wait

#eof
