/*
 * server.c
 *
 * Copyright (c) 2001 The University of Utah and the Flux Group.
 *
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

#include <stdlib.h> // NULL, malloc
#include <assert.h>

#include <nodeos/an_pbuf.h>

#include "types.h"
#include "network.h"
#include "server.h"
#include "packets.h"

int serverCount;
Server *serverList = NULL;

Server* createADoomServer(const char *serverAddr, 
			  const char *myAddr,
			  const char *protocol)
{
	Server *server;
	int i;

	server = malloc(sizeof(Server));
	server->name = serverAddr;
	server->needRetransmit = false;
	server->madeToTic = 0;
	server->lastSentTic = 0;
	server->next = serverList;
	serverList = server;
	
	for (i = 0; i < BUFS_PER_SERVER; i++)
	{
		server->recvBufPtrs[i] = an_pbuf_create(&(server->recvBufs[i]),
							AN_PBUF_DEFAULT, 0, 0);
		assert(server->recvBufPtrs[i] == &(server->recvBufs[i]));
	}

	createConnections(protocol, myAddr, serverAddr,
			  &server->recvChan,
			  recvServerData, (void*)server,
			  &server->recvDemux,
			  server->recvBufPtrs, BUFS_PER_SERVER,
			  &server->sendChan);

	return server;
}

Server* adoomServer(void)
{
	assert(serverList);
	assert(serverList->next == NULL);

	return serverList;
}


