/*
 * stats.h
 *
 * Copyright (c) 2001 The University of Utah and the Flux Group.
 *
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

#ifndef STATS_HEADER
#define STATS_HEADER

#include "tic.h"

typedef struct Stats {
	Uint32 peerCount;
	Uint32 packetSentCount;
	Uint32 packetSendErrCount;
	Uint32 packetSendBusyCount;
	Uint32 packetRecvCount;
	Uint32 serverPacketRecvCount;
	Uint32 recvTookTooLongCount;
	Uint32 lockAcquire;
	Uint32 lockRelease;
	Uint32 sleepyTimeMS;
	Uint32 sleepyTimeTicsMS;
	Uint32 setupTimeMS;
	Uint32 requestRetransmitCount;
	Uint32 doRetransmitCount;
	Uint32 doServerRetransmitCount;
	Uint32 ticDiffDistribution[MAX_TICS_AHEAD];
	Uint32 ticAdvanceDistribution[MAX_TICS_AHEAD];
	Uint32 ticSentDistribution[MAX_TICS_AHEAD];
	Uint32 ticsAheadDistribution[MAX_TICS_AHEAD];
	Uint32 ticCappedCount;
	Uint32 controllerSetupLoops;
	Uint32 packetNotNeededCount;
	Uint32 setupPacketWhileRunningCount;
	Uint32 setupPacketWhileControllerCount;
	Uint32 runningPacketDuringSetupCount;
	Uint32 avgRunningTicRate;
} FdoomStats;

extern FdoomStats fdoomStats;

#define STAT_INC(FIELD)       ((fdoomStats.FIELD)++)
#define STAT_INCBY(FIELD, BY) ((fdoomStats.FIELD)+=BY)
#define STAT_SET(FIELD, VAL)  ((fdoomStats.FIELD)=VAL)
#define STAT_DEC(FIELD)       ((fdoomStats.FIELD)--)

extern void registerStatsTrigger(void);
extern void printFinalStats(void);

#endif /* STATS_HEADER */
