/*
 * error.h
 *
 * Copyright (c) 2001 The University of Utah and the Flux Group.
 *
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

#ifndef ERROR_HEADER
#define ERROR_HEADER

#include "types.h"

#define FATALERROR(msg, args...) fatalerror(__FUNCTION__, __LINE__, msg, ## args)
extern void fatalerror(const char *func,
		       int line,
		       const char *msg, ...)
#ifdef __GNUC__
	__attribute__((format (printf, 3, 4)))
#endif
	FUNC_NO_RETURN;

#endif /* ERROR_HEADER */
