#
# Copyright (c) 2001 University of Utah and the Flux Group.
# All rights reserved.
# This file is part of Janos.
# 
# Janos is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License, version 2, as
# published by the Free Software Foundation.
# 
# Janos is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details, in the file
# COPYING.  If that file is not present, write to the Free
# Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
# 02111-1307, USA
# 
# The University of Utah and the Flux Group requests users to
# return to flux-dist@cs.utah.edu any improvements that they make.
#

TARGET =      libadoom.a
TARGET_P =    libadoom_p.a

SRCS =        error.c identity.c network.c options.c tic.c ticlist.c trace.c \
	      an_printf.c
OBJS :=       $(subst .c,.o,$(SRCS))
OBJS_P :=     $(subst .c,.po,$(SRCS))

all_p: libadoom_p.a
all: libadoom.a

include $(NODEOS_SRCDIR)/envs/define_vars.mk

install:
	@echo "No install step for adoomlib"

$(TARGET): $(OBJS)
	$(SILENT_MAKE_INFORM) "Creating library $@."
	$(AR) cru $@ $^
	$(RANLIB) $@

$(TARGET_P): $(OBJS_P)
	$(SILENT_MAKE_INFORM) "Creating library $@."
	$(AR) cru $@ $^
	$(RANLIB) $@

clean:
	$(SILENT_MAKE_INFORM) "Removing *.o *.po $(TARGET) $(TARGET_P)"
	rm -f .depend core .core *.d *.o *.po $(TARGET) $(TARGET_P)

distclean: clean
	$(SILENT_MAKE_INFORM) "Scrubbing adoomlib directory."
	rm -f GNUmakefile

mkdebug:
	@echo "SRCS = $(SRCS)"
	@echo "OBJS = $(OBJS)"

check:
