/*
 * network.h
 *
 * Copyright (c) 2001 The University of Utah and the Flux Group.
 *
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

#ifndef NETWORK_HEADER
#define NETWORK_HEADER

#include <nodeos/an_chan.h>

#include "types.h"

void strtoaddrport(const char *id, Uint32 *addr, Uint16 *port);

/*
 * Create a send chan to the given peer, and
 * create a recv chan for that peer.  Initialize
 * all the state in the given memory.
 */
void createConnections(const char* protocolId, 
		       const char* myAddr,
		       const char* peerAddr,
		       an_chan_t* recvChan,
		       an_chanrecvfunc_t recvFunc,
		       void *recvArg,
		       an_demuxkey_t* recvDemux,
		       an_pbuf_t* recvBufs[], 
		       int recvBufCount,
		       an_chan_t* sendChan);

#endif /* NETWORK_HEADER */
