/*
 * ticlist.h
 *
 * Copyright (c) 2001 The University of Utah and the Flux Group.
 *
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

#ifndef TICLIST_HEADER
#define TICLIST_HEADER

#include "tic.h"
#include "packetTypes.h"

typedef struct TicList
{
	/* Number of tics in this list */
	int size;
	/* Contiguous memory allocated for tics */
	void *ticChunk;
	/* Array of pointers off to ticChunk.  Actual tic's */
	TicCommand *tics[TIC_HISTORY_LEN];
	/* Debug sanity check */
	DEBUGONLY(Tic whichTics[TIC_HISTORY_LEN]);
} TicList;

void ticListInit(TicList *tl);
void ticListDestroy(TicList *tl);
void ticListCopyTicOut(TicList *tl, Tic tic, TicCommand *dest);
void ticListInsertOneTic(TicList *tl, Tic tic, TicCommand *src);
TicCommand *ticListGetTicForPut(TicList *tl, Tic tic);
TicCommand *ticListGetTicForGet(TicList *tl, Tic tic);
void ticListInsertRunningPacket(TicList *tl, RunningPacket *packet);

#endif /* TICLIST_HEADER */
