/*
 * Copyright (c) 1999, 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

/*
 * Simple hello world EE
 */

#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <pthread.h>

#include <nodeos/an_impl.h>
#include <nodeos/an_domain.h>
#include <nodeos/an_thread.h>

static void ee_init(void *arg);
an_domaininit_func_t InitEE = { ee_init };

int
ee_main(int argc, char **argv)
{
#if defined(OSKIT) && defined(GPROF)
	oskit_start_gprof();
#endif
	printf("%s: Hello, world\n", argv[0]);
#if 0
	{
		int i;

		printf("My %d args are:\n", argc);
		for (i = 0; i < argc; i++)
			printf(" [%d]: `%s'\n", i, argv[i]);
	}
#endif
#if defined(OSKIT) && defined(GPROF)
	oskit_stop_gprof();
#endif
	printf("null: PASS\n");
	return 0;
}

static void
ee_init(void *arg)
{
	an_initargs_t *args = arg;
	int status;

	status = ee_main(args->argc, args->argv);
	an_domain_destroy(an_domain_current());
}
