/*
 * Copyright (c) 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

#ifndef MOAB_ENVS_TIMEOUT_H
#define MOAB_ENVS_TIMEOUT_H

/*
 * this is a simple hack for all the example programs that
 * need a die timeout.
 */

static void set_die_timeout(int seconds, void (*func)(an_event_t* ev, void *arg));

static void set_die_timeout(int seconds, void (*func)(an_event_t* ev, void *arg))
{
	static an_event_t ev;
	an_timespec_t dietime;
	an_error_t err;
	
	an_event_create(&ev);

	dietime.tv_sec = seconds;
	dietime.tv_nsec = 0;

	err = an_event_schedule(&ev, &dietime,
				AN_EVTYPE_ONESHOT_RELATIVE,
				func, NULL);
	assert(err == 0);
}

#endif /* MOAB_ENVS_TIMEOUT_H */
