/*
 * Copyright (c) 1999, 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

/*
 * Moab Debugging API
 */
#ifndef _NODEOS_DEBUG_H_
#define _NODEOS_DEBUG_H_

#ifdef NODEOS_SPEC_COMPAT
/* XXX */
#endif

#include <nodeos/an_error.h>
#include <nodeos/impl/an_debug.h>

/*
 * Set the internal debugging mask based on the given string. 
 * The valid values for the mask are dependent upon the internal
 * debugging in Moab.  See ani_debug.c for details.  Or invoke
 * this method with the argument "list" to get a listing of the
 * options printed to standard out.
 *
 * This function will *not* use any other an_* functions as it can
 * be called before an_moab_setup().  Thus, it does
 * not "enter" the nodeos or anything.  Nor does it allocate any memory 
 * or print anything to a console or anything.
 *
 * Returns NULL if things went okay, otherwise
 * returns a pointer to the maskstr element that
 * caused a problem.
 */
const char *an_debug_setmask(const char *maskstr);

#endif /* _NODEOS_DEBUG_H_ */
