/*
 * Copyright (c) 1999, 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

NODEOS_FUNC_INLINE void
assert_ani_cred_valid(ani_cred_t *cred) 
{
	assert(cred != 0);

#ifdef DEBUG
	if (cred != ani_root_credential) {
		extern ani_resource_t ani_moab_noderes;

		assert(cred->limits.threads <= ani_moab_noderes.threads);
		assert(cred->limits.cpurate <= ani_moab_noderes.cpurate);
		assert(cred->limits.timeslice <= ani_moab_noderes.timeslice);
		assert(cred->limits.stacksize <= 128 * 1024);
		assert(cred->limits.memtotal <= ani_moab_noderes.memtotal);

		/* Current usage should be below limits */
		assert(cred->current.threads <= cred->limits.threads);
		assert(cred->current.cpurate <= cred->limits.cpurate);
		assert(cred->current.timeslice <= cred->limits.timeslice);
		assert(cred->current.stacksize == 0
		       || cred->current.stacksize > 20*1024);	/* XXX oskit */
		assert(cred->current.stacksize <= cred->limits.stacksize);
		assert(cred->current.memtotal <= cred->limits.memtotal);
	} else {
		assert(cred->current.threads == 0);
		assert(cred->current.cpurate == 0);
		assert(cred->current.timeslice == 0);
		assert(cred->current.stacksize == 0);
		assert(cred->current.memtotal == 0);
	}
#endif /* DEBUG */
}

