/*
 * Copyright (c) 1999-2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

/*
 * Return non-zero if an error was signaled, 0 if the given error
 * object is clear.
 */
NODEOS_FUNC_INLINE int
ani_error_occured(ani_error_t err)
{
	return (int)err;
}

/*
 * Returns an integer value describing the error.
 * XXX right now this does nothing.  But someday, if ani_error_ts are more
 * than just a simple integer, this routine will map the complex type into
 * a simple integer to match the existing NodeOS API implementation.
 */
NODEOS_FUNC_INLINE int
ani_error_code(ani_error_t err)
{
	return (int)err;
}

/*
 * Initialize an ani_error_t instance to reflect no error.
 */
NODEOS_FUNC_INLINE ani_error_t
ani_error_clear(void)
{
	return 0;
}

