/*
 * Copyright (c) 2000-2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

#ifndef _NODEOS_ANI_FS_H_
#define _NODEOS_ANI_FS_H_

#include <nodeos/impl/an_impl.h>
#include <nodeos/ani/ani_error.h>

/* just a unix FD */
typedef int ani_file_t;

/* Prototypes */

ani_error_t ani_file_stat(const char *path, an_stat_t *anstat);
ani_error_t ani_file_fstat(ani_file_t *file, an_stat_t *anstat);

#include <stdio.h>	/* rename */
#include <fcntl.h>	/* open */
#include <sys/stat.h>	/* mkdir */
#include <errno.h>	/* errno */
#include <unistd.h>	/* everything else */

#include <nodeos/ani/ani_fs_inline.h>

#endif /* _NODEOS_ANI_FS_H_ */
