/*
 * Copyright (c) 1999-2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

/*
 * ani_ilock_*
 *
 * Internal locking, just use pthreads sans errors.
 *
 * All the ani_ilock and ani_icond functions are inlined.
 */
#ifndef _NODEOS_ANI_ILOCK_H_
#define _NODEOS_ANI_ILOCK_H_

#undef ILOCKSTATS

#include <pthread.h>
#include <errno.h>
#include <assert.h>

#include <nodeos/impl/decls.h>

/* types */

typedef struct ani_ilock {
	pthread_mutex_t lock;
#ifdef ILOCKSTATS
	unsigned int got;
	unsigned int failed;
#endif
} ani_ilock_t;
typedef pthread_cond_t ani_icond_t;

#include <nodeos/ani/ani_ilock_inline.h>

#endif /* _NODEOS_ANI_ILOCK_H_ */
