/*
 * Copyright (c) 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

#ifndef _ANI_LOG_H_
#define _ANI_LOG_H_

#include <nodeos/an_log.h>

/* Internal NodeOS logging priorities */
#define ANI_LOG_HIGH	(ANI_LOG_LOW+2)

#define ANI_LOG_PANIC	(ANI_LOG_LOW+3)
#define ANI_LOG_WARN	(ANI_LOG_LOW+2)
#define ANI_LOG_INFO	(ANI_LOG_LOW+1)
#define ANI_LOG_DEBUG	(ANI_LOG_LOW+0)

#define ANI_LOG_LOW	(AN_LOG_HIGH+1)

/* inline functions */

/* prototypes */

/*
 * Write a fixed length buffer to a system log
 */
void ani_log_write(int prio, void *buf, int buflen);

/*
 * Printf-style interfaces
 */
void ani_log_printf(int prio, const char *fmt, ...);
void ani_log_vprintf(int prio, const char *fmt, void *args);

#endif /* _ANI_LOG_H_ */
