/*
 * Copyright (c) 1999-2002 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

NODEOS_FUNC_INLINE struct ani_domain *
ani_threadpool_domain(ani_threadpool_t *tpool)
{
	assert(tpool != NULL);
	return tpool->domain;
}

NODEOS_FUNC_INLINE void 
ani_threadpool_lock(ani_threadpool_t *tpool) 
{
        ani_ilock_lock(&tpool->lock);
}

NODEOS_FUNC_INLINE int
ani_threadpool_trylock(ani_threadpool_t *tpool) 
{
        return ani_ilock_trylock(&tpool->lock);
}

NODEOS_FUNC_INLINE void 
ani_threadpool_unlock(ani_threadpool_t *tpool) 
{
        ani_ilock_unlock(&tpool->lock);
}

NODEOS_FUNC_INLINE int
ani_threadpool_islocked(ani_threadpool_t *tpool) 
{
        return ani_ilock_islocked(&tpool->lock);
}

NODEOS_FUNC_INLINE void
ani_threadpool_reference(ani_threadpool_t *tpool) 
{
        tpool->refs++;
}

NODEOS_FUNC_INLINE void
ani_threadpool_release(ani_threadpool_t *tpool) 
{
        if (--tpool->refs == 0) 
                ani_threadpool_cleanup(tpool);
}

NODEOS_FUNC_INLINE void
assert_ani_threadpool_valid(ani_threadpool_t *tpool) 
{
	assert(tpool != 0);
#ifdef MEMDEBUG
	assert(tpool != (void *)0xdddddddd);
	assert(*(unsigned int *)tpool != 0xdddddddd);
#endif
}

