/*
 * Copyright (c) 2000-2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

/* inline functions */

NODEOS_FUNC_INLINE int
ani_threadwork_busy(ani_threadwork_t *w)
{
        assert(w);
        return (w->func != 0);
}

NODEOS_FUNC_INLINE void
ani_threadwork_init(ani_threadwork_t *w)
{
        assert(w);
	w->func = 0;
}

NODEOS_FUNC_INLINE void
ani_threadwork_set(ani_threadwork_t *w, int inkern, struct ani_chan *chan,
		  ani_thread_func_t func, void *farg1, void *farg2, void *farg3)
{
	assert(func != 0);
	assert(w != 0);
	assert(w->func == 0);

	w->next = 0;
	w->inkern = inkern;
	w->chan = chan;
	w->func = func;
	w->farg[0] = farg1;
	w->farg[1] = farg2;
	w->farg[2] = farg3;
}
