/*
 * Copyright (c) 2000-2002 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

/*
 * Implementation bits of NodeOS channel API.
 */
#ifndef _NODEOS_IMPL_AN_CHAN_H_
#define _NODEOS_IMPL_AN_CHAN_H_

/*
 * an_chan interfaces.  
 *
 * An index into the caller domain's object table.
 * This layer add the NODEOS entry/exit and INTERN/EXTERN mapping to
 * the internal structure.
 */

typedef struct an_chan {
	int index;		/* descriptor table index */
} an_chan_t;

#define AN_SIZEOF_CHAN	sizeof(an_chan_t)

/* extensions */

an_chan_t *an_clickcutchan_create(void *mem, an_domain_t *domain,
				  char *config_string,
				  an_chan_t *inchan, an_chan_t *outchan);
an_error_t an_clickcutchan_destroy(an_chan_t *chan);

an_chan_t *an_clickinchan_create(void *mem, an_domain_t *domain,
				 an_demuxkey_t *key, an_chanproto_t *proto,
				 an_chanaddr_t *addr, an_netspec_t *net,
				 an_chanrecvfunc_t func, void *farg,
				 an_chan_t *inchan);

an_chan_t *an_clickoutchan_create(void *mem, an_domain_t *domain,
				  an_chanproto_t *proto, an_chanaddr_t *addr,
				  an_netspec_t *net,
				  an_chan_t *outchan);

#endif /* _NODEOS_IMPL_AN_CHAN_H_ */
