/*
 * Copyright (c) 2000-2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

struct ani_domain;

/* an_cred inline functions */

/* XXX NODEOS_CREATE_CRED is not inlined due to cyclic include problems */
/* XXX NODEOS_DESTROY_CRED is not inlined due to cyclic include problems */

NODEOS_FUNC_INLINE struct ani_cred *
NODEOS_INTERN_CRED(struct ani_domain *domain, an_cred_t *xcred)
{
	assert(xcred != 0);
	return &xcred->cred;
}

NODEOS_FUNC_INLINE an_cred_t *
NODEOS_EXTERN_CRED(struct ani_domain *domain, struct ani_cred *icred)
{
	assert(icred != 0);
	return (an_cred_t *)icred;
}

NODEOS_FUNC_INLINE an_cred_t *
an_cred_current(void)
{
	an_cred_t *cred;

	LW_NODEOS_ENTER;
	cred = NODEOS_EXTERN_CRED(0, ani_cred_current());
	LW_NODEOS_LEAVE;
	return cred;
}
