/*
 * Copyright (c) 2000-2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

/*
 * Implementation bits of NodeOS demuxkey API.
 */
#ifndef _NODEOS_IMPL_AN_DEMUXKEY_H_
#define _NODEOS_IMPL_AN_DEMUXKEY_H_

#include <nodeos/impl/decls.h>
#include <nodeos/ani/ani_nodeos.h>
#include <nodeos/ani/ani_demuxkey.h>

/*
 * an_demuxkey interfaces.  
 *
 * an_demuxkeys are a simple wrapper around the ani_demuxkey layer.
 * This layer add the NODEOS entry/exit and INTERN/EXTERN to the ani_demuxkey.
 */

typedef struct an_demuxkey {
	struct ani_demuxkey demuxkey;
	void *nodeosobj;
} an_demuxkey_t;

#include <nodeos/impl/an_demuxkey_inline.h>

#endif /* _NODEOS_IMPL_AN_DEMUXKEY_H_ */
