/*
 * Copyright (c) 2000-2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

struct ani_domain;

/* an_demuxkey inline functions */

/* XXX NODEOS_CREATE_DEMUXKEY is not inlined due to cyclic include problems */
/* XXX NODEOS_DESTROY_DEMUXKEY is not inlined due to cyclic include problems */

NODEOS_FUNC_INLINE struct ani_demuxkey *
NODEOS_INTERN_DEMUXKEY(struct ani_domain *domain, an_demuxkey_t *xdemuxkey)
{
	assert(xdemuxkey != 0);
	return &xdemuxkey->demuxkey;
}

NODEOS_FUNC_INLINE an_demuxkey_t *
NODEOS_EXTERN_DEMUXKEY(struct ani_domain *domain, struct ani_demuxkey *idemuxkey)
{
	assert(idemuxkey != 0);
	return (an_demuxkey_t *)idemuxkey;
}

NODEOS_FUNC_INLINE an_error_t
an_demuxkey_len(an_demuxkey_t *key, int *len)
{
	ani_error_t err;

	NODEOS_ENTER;
	err = ani_demuxkey_len(&key->demuxkey, len);
	NODEOS_LEAVE;
	return NODEOS_EXTERN_ERROR(err);
}
