/*
 * Copyright (c) 2000-2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

/* an_domain inline functions */

/* XXX NODEOS_CREATE_DOMAIN is not inlined due to cyclic include problems */
/* XXX NODEOS_DESTROY_DOMAIN is not inlined due to cyclic include problems */

NODEOS_FUNC_INLINE struct ani_domain *
NODEOS_INTERN_DOMAIN(struct ani_domain *domain, an_domain_t *xdomain)
{
	assert(xdomain != 0);
	return &xdomain->domain;
}

NODEOS_FUNC_INLINE an_domain_t *
NODEOS_EXTERN_DOMAIN(struct ani_domain *domain, struct ani_domain *idomain)
{
	assert(idomain != 0);
	return (an_domain_t *)idomain;
}

NODEOS_FUNC_INLINE an_domain_t *
an_domain_current(void)
{
	an_domain_t *domain;

	LW_NODEOS_ENTER;
	domain = NODEOS_EXTERN_DOMAIN(0, ani_domain_current());
	LW_NODEOS_LEAVE;
	return domain;
}
