/*
 * Copyright (c) 2000-2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

struct ani_domain;

/* an_mempool inline functions */

/* XXX NODEOS_CREATE_MEMPOOL is not inlined due to cyclic include problems */
/* XXX NODEOS_DESTROY_MEMPOOL is not inlined due to cyclic include problems */

NODEOS_FUNC_INLINE struct ani_mempool *
NODEOS_INTERN_MEMPOOL(struct ani_domain *domain, an_mempool_t *xmempool)
{
	assert(xmempool != 0);
	return &xmempool->mempool;
}

NODEOS_FUNC_INLINE an_mempool_t *
NODEOS_EXTERN_MEMPOOL(struct ani_domain *domain, struct ani_mempool *imempool)
{
	assert(imempool != 0);
	return (an_mempool_t *)imempool;
}

NODEOS_FUNC_INLINE an_mempool_t *
an_mempool_current(void)
{
	an_mempool_t *xmempool;

	LW_NODEOS_ENTER;
	xmempool = NODEOS_EXTERN_MEMPOOL(0, ani_mempool_current());
	LW_NODEOS_LEAVE;
	return xmempool;
}

