/*
 * Copyright (c) 2000-2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

/*
 * Implementation bits of NodeOS mutex API.
 */
#ifndef _NODEOS_IMPL_AN_MUTEX_H_
#define _NODEOS_IMPL_AN_MUTEX_H_

#include <nodeos/impl/decls.h>
#include <nodeos/an_error.h>
#include <nodeos/ani/ani_nodeos.h>
#include <nodeos/ani/ani_mutex.h>

/*
 * an_mutex interfaces.  
 *
 * an_mutexes are a simple wrapper around the ani_mutex layer.
 * This layer add the NODEOS entry/exit and INTER/EXTERN to the 
 * ani_mutex.
 *
 * The Utah NodeOS inlines the lock(), unlock() and trylock()
 * operations.  The init() and destroy() operations are not inlined.
 */

typedef struct an_mutex {
	struct ani_mutex mutex;	/* must be first for INTERN/EXTERN */
	void *nodeosobj;
} an_mutex_t;

#include <nodeos/impl/an_mutex_inline.h>

#endif /* _NODEOS_IMPL_AN_MUTEX_H_ */


