/*
 * Copyright (c) 2000-2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

struct ani_domain;

/* an_mutex inline functions */

/* XXX NODEOS_CREATE_MUTEX is not inlined due to cyclic include problems */
/* XXX NODEOS_DESTROY_MUTEX is not inlined due to cyclic include problems */

NODEOS_FUNC_INLINE struct ani_mutex *
NODEOS_INTERN_MUTEX(struct ani_domain *domain, an_mutex_t *xmutex)
{
	assert(xmutex != 0);
	return &xmutex->mutex;
}

NODEOS_FUNC_INLINE an_mutex_t *
NODEOS_EXTERN_MUTEX(struct ani_domain *domain, struct ani_mutex *imutex)
{
	assert(imutex != 0);
	return (an_mutex_t *)imutex;
}

NODEOS_FUNC_INLINE void 
an_mutex_lock(an_mutex_t *m)
{
	NODEOS_ENTER;
	ani_mutex_lock(&m->mutex);
	NODEOS_LEAVE;
}


NODEOS_FUNC_INLINE int
an_mutex_trylock(an_mutex_t *m)
{
	int rv;

	NODEOS_ENTER;
	rv = ani_mutex_trylock(&m->mutex);
	NODEOS_LEAVE;
	return rv;
}

NODEOS_FUNC_INLINE void 
an_mutex_unlock(an_mutex_t *m)
{
	NODEOS_ENTER;
	ani_mutex_unlock(&m->mutex);
	NODEOS_LEAVE;
}

