/*
 * Copyright (c) 2000-2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

struct ani_domain;

/* an_thread inline functions */

/* XXX NODEOS_CREATE_THREAD is not inlined due to cyclic include problems */
/* XXX NODEOS_DESTROY_THREAD is not inlined due to cyclic include problems */

NODEOS_FUNC_INLINE struct ani_thread *
NODEOS_INTERN_THREAD(struct ani_domain *domain, an_thread_t *xthread)
{
	assert(xthread != 0);
	return &xthread->thread;
}

NODEOS_FUNC_INLINE an_thread_t *
NODEOS_EXTERN_THREAD(struct ani_domain *domain, struct ani_thread *ithread)
{
	assert(ithread != 0);
	return (an_thread_t *)ithread;
}

NODEOS_FUNC_INLINE an_thread_t *
an_thread_current(void)
{
	an_thread_t *thread;

	LW_NODEOS_ENTER;
	thread = NODEOS_EXTERN_THREAD(0, ani_thread_current());
	LW_NODEOS_LEAVE;
	return thread;
}

