/*
 * Copyright (c) 1999, 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

#ifndef _NODEOS_LIB_UTILS_H_
#define _NODEOS_LIB_UTILS_H_

#include <nodeos/an_error.h>

/*
 * Random goop
 */

unsigned short ipcksum(void *buf, int nbytes);

/*
 * Stats
 */
struct an_chan;
struct an_domain;
struct an_mempool;
an_error_t moab_chan_printstats(struct an_chan *chan, int verbose,
				const char *str, int interval, int accum);
an_error_t moab_chan_printstatsdelta(struct an_chan *chan, int verbose,
				     const char *str, int interval,
				     void **cookie);
an_error_t moab_domain_printstats(struct an_domain *domain, int verbose,
				const char *str, int interval, int accum);
an_error_t moab_domain_printstatsdelta(struct an_domain *domain, int verbose,
				     const char *str, int interval,
				     void **cookie);
an_error_t moab_mempool_printstats(struct an_mempool *mpool, int verbose,
				   const char *str, int accum);

#endif /* _NODEOS_LIB_UTILS_H_ */
