/*
 * Copyright (c) 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

/*
 * Log API functions
 */
#include <nodeos/an_log.h>

#include <nodeos/ani/ani_nodeos.h>
#include <nodeos/ani/ani_log.h>

an_error_t
an_log_write(int prio, void *buf, int buflen)
{
	ani_error_t err;

	NODEOS_ENTER;

	if (prio < AN_LOG_LOW || prio > AN_LOG_HIGH) {
		err = ani_error_set(AN_ERR_INVALIDARG,
				    "invalid priority argument");
		goto done; 
	}

	/*
	 * N.B. no copyin needed in our implemenation
	 */
	ani_log_write(prio, buf, buflen);
	err = ani_error_clear();

 done:
	NODEOS_LEAVE;
	return NODEOS_EXTERN_ERROR(err);
}
