/*
 * Copyright (c) 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */
#include <nodeos/ani/ani_domain.h>
#include <nodeos/ani/ani_mempool.h>

/*
 * These exist as non-inlined functions solely to avoid circular include file
 * hell.  If ani_mempool functions were to be called directly from the
 * an_foo_inline.h NODEOS_CREATE_FOO functions, those header files would have
 * to include ani_domain.h and ani_mempool.h and that gets big time ugly.
 */
void *
nodeos_obj_alloc(ani_domain_t *domain, int size)
{
	assert(domain != 0);
	return ani_mempool_alloc(ani_domain_mempool(domain), size);
}

void
nodeos_obj_free(ani_domain_t *domain, void *obj, int size)
{
	assert(domain != 0);
	ani_mempool_free(ani_domain_mempool(domain), obj, size);
}
