/*
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <oskit/startup.h>

#include "ani_os.h"

/*
 * Some reasonable defaults (well, for me).
 */
#define DISK_NAME	"wd1"
#define PART_NAME	"b"

/*
 * OSKit filesystem interfaces
 */
void
ani_os_init_fs(void)
{
	start_fs_bmod_pthreads();

#ifdef	HAVE_DISK
	char *option;
	char *diskname = DISK_NAME;
	char *partname = PART_NAME;

	if ((option = getenv("DISK")) != NULL)
		diskname = option;
	
	if ((option = getenv("PART")) != NULL)
		partname = option;

	ani_log_printf(ANI_LOG_INFO,
		       "Initializing filesystem on %s%s\n", diskname, partname);

	start_fs_pthreads(diskname, partname);
#endif
}

void
ani_os_deinit_fs(void)
{
	/* sync? */
}
