/*
 * Copyright (c) 1999, 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */
#include <stdio.h>
#include <stdarg.h>

#include <nodeos/config.h>
#include <nodeos/ani/ani_log.h>

#include "ani_os.h"

/*
 * Write a buffer to a logfile.
 *
 * Note: this function may be called very early in the initialization
 * or very late in shutdown of Moab and hence must work independent of the
 * state of the NodeOS.
 */
void
ani_os_log_write(int prio, void *buf, int buflen)
{
	FILE *fd = stdout;

	if (prio == ANI_LOG_DEBUG)
		fd = stderr;
	fwrite(buf, 1, buflen, fd);
}

/*
 * Emergency shutdown function
 */
void
ani_os_panic(const char *fmt, ...)
{
	va_list vl;

	va_start(vl, fmt);
	vprintf(fmt, vl);
	va_end(vl);

	printf("\n");

	_exit(1);
}

void
ani_os_dump_state(void *state)
{
}

