/*
 * Copyright (c) 1999, 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

#ifndef _UNIX_ETH_IMPL_H_
#define _UNIX_ETH_IMPL_H_

#include <netinet/if_ether.h>

struct if_info {
	unsigned char name[IFNAMSIZ];
	unsigned char addr[6];
};


int unix_eth_get_if_info(struct if_info **nfo);
void unix_eth_free_if_info(int ndev, struct if_info *nfo);

int ani_os_open_eth(char *dev);
void ani_os_close_eth(int fd);

/*
 * Read packets from an ethernet interface.
 * Will read a single packet at a time into ``buf'' with max size ``bufsize''.
 * Returns the size of the packet read or -1 on an error.
 *
 * The ``timeo'' parameter specifies a timeout in milliseconds, if no
 * packet is read within the timeout value, the routine returns 0.
 */
int ani_os_read_eth(int fd, char *buf, int bufsize, int timeo);

int ani_os_write_eth(int fd, char *buf, int bufsize);

#endif /* _UNIX_ETH_IMPL_H_ */

