/*
 * Copyright (c) 1999, 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

#include <unistd.h>
#include <string.h>
#include <sys/param.h>
#if defined(__sun__)
#include <netdb.h>
/* XXX our solaris box doesn't have a prototype. */
extern int sethostname(const char *n, int l);
#endif

#include <nodeos/an_error.h>

static const char ani_hostname_buf[MAXHOSTNAMELEN];

const char *
ani_os_gethostname(void)
{
	int err;
	err = gethostname((char *)ani_hostname_buf, MAXHOSTNAMELEN);
	if (err)
		return NULL;
	return ani_hostname_buf;
}

int
ani_os_sethostname(const char *name)
{
	int err;
	err = sethostname(name, strlen(name));
	if (err)
		return EPERM;
	return 0;
}

