/*
 * Copyright (c) 1999, 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

#include "ani_os.h"

/*
 * Solaris, FreeBSD and Linux already initialized all this stuff for
 * us...
 */

void
ani_os_init_basic(void)
{
}

void
ani_os_init_mem(void)
{
}

void
ani_os_init_devices(void)
{
}

void
ani_os_init_net(void)
{
}

void
ani_os_deinit_net(void)
{
}

void
ani_os_init_resources(ani_resource_t *res)
{
	/*
	 * XXX Fer now hack
	 */
	res->threads = 100;		/* units: # of threads */
	res->timeslice = 10000;		/* units: microseconds */
	res->cpurate = 1*1000*1000;	/* units: cycles per second */
	res->memtotal = 128*1024*1024;	/* units: bytes */
	res->netrate = 100*1000*1000;	/* units: bits per second */

	res->stacksize = 128 * 1024;	/* XXX doesn't belong */
}

/*
 * XXX doesn't belong here
 */
void
ani_os_time_current(an_timespec_t *curtime)
{
	struct timeval tv;
	int err;

	err = gettimeofday(&tv, 0);
	assert(err == 0);
	curtime->tv_sec = tv.tv_sec;
	curtime->tv_nsec = tv.tv_usec * 1000;
}
